(function() {
  var client, coffeescript_helpers, express, fs, jquery, jsdom, log, path, rewrite_function, sammy, socketio, zappa;
  var __slice = Array.prototype.slice, __indexOf = Array.prototype.indexOf || function(item) {
    for (var i = 0, l = this.length; i < l; i++) {
      if (this[i] === item) return i;
    }
    return -1;
  };
  zappa = {
    version: '0.2.0beta'
  };
  log = console.log;
  fs = require('fs');
  path = require('path');
  express = require('express');
  socketio = require('socket.io');
  jsdom = require('jsdom');
  jquery = fs.readFileSync(__dirname + '/../vendor/jquery-1.6.2.min.js').toString();
  sammy = fs.readFileSync(__dirname + '/../vendor/sammy-latest.min.js').toString();
  coffeescript_helpers = "var __slice = Array.prototype.slice;\nvar __hasProp = Object.prototype.hasOwnProperty;\nvar __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };\nvar __extends = function(child, parent) {\n  for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }\n  function ctor() { this.constructor = child; }\n  ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype;\n  return child; };\nvar __indexOf = Array.prototype.indexOf || function(item) {\n  for (var i = 0, l = this.length; i < l; i++) {\n    if (this[i] === item) return i;\n  } return -1; };".replace(/\n/g, '');
  rewrite_function = function(func, locals_names) {
    var code, name, _i, _len;
    code = String(func);
    if (!code.indexOf('function' === 0)) {
      code = "function () {" + code + "}";
    }
    code = "" + coffeescript_helpers + "return (" + code + ").apply(context, args);";
    for (_i = 0, _len = locals_names.length; _i < _len; _i++) {
      name = locals_names[_i];
      code = ("var " + name + " = locals." + name + ";") + code;
    }
    return new Function('context', 'locals', 'args', code);
  };
  client = require('./client').build(zappa.version, coffeescript_helpers, rewrite_function);
  zappa.app = function() {
    var a, app, data, defs, defs_names, externals_names, g, globals_names, helpers, helpers_names, http_names, io, k, postrender_names, postrenders, r, rewritten_root, root_context, root_function, root_locals, root_names, routes, v, verb, views, ws_handlers, ws_names, _fn, _fn2, _i, _j, _k, _l, _len, _len2, _len3, _len4, _ref;
    data = null;
    root_function = null;
    for (_i = 0, _len = arguments.length; _i < _len; _i++) {
      a = arguments[_i];
      switch (typeof a) {
        case 'function':
          root_function = a;
          break;
        case 'object':
          data = a;
      }
    }
    globals_names = ['global', 'process', 'console', 'setTimeout', 'clearTimeout', 'setInterval', 'clearInterval', 'require', 'module', '__filename', '__dirname'];
    root_names = ['zappa', 'express', 'app', 'io', 'requiring', 'get', 'post', 'put', 'del', 'at', 'helper', 'def', 'view', 'set', 'use', 'configure', 'include', 'shared', 'client', 'coffee', 'js', 'css', 'enable', 'disable', 'settings', 'postrender'];
    http_names = ['app', 'settings', 'response', 'request', 'next', 'params', 'send', 'render', 'redirect'];
    ws_names = ['app', 'io', 'settings', 'socket', 'id', 'params', 'client', 'emit', 'broadcast'];
    postrender_names = ['window', '$'];
    externals_names = [];
    for (k in data) {
      v = data[k];
      externals_names.push(k);
    }
    helpers_names = [];
    defs_names = [];
    routes = [];
    ws_handlers = {};
    helpers = {};
    defs = {};
    views = {};
    postrenders = {};
    express.View.prototype.__defineGetter__('exists', function() {
      if (views[this.view] != null) {
        return true;
      }
      if (views[path.basename(this.view)] != null) {
        return true;
      }
      try {
        fs.statSync(this.path);
        return true;
      } catch (err) {
        return false;
      }
    });
    express.View.prototype.__defineGetter__('contents', function() {
      if (views[this.view] != null) {
        return views[this.view];
      }
      if (views[path.basename(this.view)] != null) {
        return views[path.basename(this.view)];
      }
      return fs.readFileSync(this.path, 'utf8');
    });
    app = express.createServer();
    io = socketio.listen(app);
    app.set('view engine', 'coffee');
    app.register('.coffee', zappa.adapter(require('coffeekup').adapters.express, {
      blacklist: ['format', 'autoescape', 'locals', 'hardcode', 'cache']
    }));
    root_context = {};
    root_locals = {
      zappa: zappa,
      express: express,
      app: app,
      io: io
    };
    for (k in data) {
      v = data[k];
      root_locals[k] = v;
    }
    for (_j = 0, _len2 = globals_names.length; _j < _len2; _j++) {
      g = globals_names[_j];
      root_locals[g] = eval(g);
    }
    root_locals.module = module.parent;
    root_locals.__filename = module.parent.filename;
    root_locals.__dirname = path.dirname(module.parent.filename);
    require.paths.unshift(root_locals.__dirname);
    _ref = ['get', 'post', 'put', 'del'];
    _fn = function(verb) {
      return root_locals[verb] = function() {
        var k, v, _ref2, _results;
        if (typeof arguments[0] !== 'object') {
          return routes.push({
            verb: verb,
            path: arguments[0],
            handler: arguments[1]
          });
        } else {
          _ref2 = arguments[0];
          _results = [];
          for (k in _ref2) {
            v = _ref2[k];
            _results.push(routes.push({
              verb: verb,
              path: k,
              handler: v
            }));
          }
          return _results;
        }
      };
    };
    for (_k = 0, _len3 = _ref.length; _k < _len3; _k++) {
      verb = _ref[_k];
      _fn(verb);
    }
    root_locals.client = function(obj) {
      var js, k, v, _results;
      app.enable('serve zappa');
      _results = [];
      for (k in obj) {
        v = obj[k];
        js = ";zappa.run(" + v + ");";
        _results.push(routes.push({
          verb: 'get',
          path: k,
          handler: js,
          contentType: 'js'
        }));
      }
      return _results;
    };
    root_locals.coffee = function(obj) {
      var js, k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        js = ";" + coffeescript_helpers + "(" + v + ")();";
        _results.push(routes.push({
          verb: 'get',
          path: k,
          handler: js,
          contentType: 'js'
        }));
      }
      return _results;
    };
    root_locals.js = function(obj) {
      var js, k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        js = String(v);
        _results.push(routes.push({
          verb: 'get',
          path: k,
          handler: js,
          contentType: 'js'
        }));
      }
      return _results;
    };
    root_locals.css = function(obj) {
      var css, k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        css = String(v);
        _results.push(routes.push({
          verb: 'get',
          path: k,
          handler: css,
          contentType: 'css'
        }));
      }
      return _results;
    };
    root_locals.helper = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        helpers_names.push(k);
        _results.push(helpers[k] = v);
      }
      return _results;
    };
    root_locals.def = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        defs_names.push(k);
        _results.push(defs[k] = v);
      }
      return _results;
    };
    root_locals.postrender = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        _results.push(postrenders[k] = v);
      }
      return _results;
    };
    root_locals.at = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        _results.push(ws_handlers[k] = v);
      }
      return _results;
    };
    root_locals.view = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        _results.push(views[k] = v);
      }
      return _results;
    };
    root_locals.set = function(obj) {
      var k, v, _results;
      _results = [];
      for (k in obj) {
        v = obj[k];
        _results.push(app.set(k, v));
      }
      return _results;
    };
    root_locals.enable = function() {
      var i, _l, _len4, _results;
      _results = [];
      for (_l = 0, _len4 = arguments.length; _l < _len4; _l++) {
        i = arguments[_l];
        _results.push(app.enable(i));
      }
      return _results;
    };
    root_locals.disable = function() {
      var i, _l, _len4, _results;
      _results = [];
      for (_l = 0, _len4 = arguments.length; _l < _len4; _l++) {
        i = arguments[_l];
        _results.push(app.disable(i));
      }
      return _results;
    };
    root_locals.use = function() {
      var a, k, use, v, wrappers, _l, _len4, _results;
      wrappers = {
        static: function(path) {
          if (path == null) {
            path = root_locals.__dirname + '/public';
          }
          return express.static(path);
        }
      };
      use = function(name, arg) {
        if (arg == null) {
          arg = null;
        }
        if (wrappers[name]) {
          return app.use(wrappers[name](arg));
        } else if (typeof express[name] === 'function') {
          return app.use(express[name](arg));
        }
      };
      _results = [];
      for (_l = 0, _len4 = arguments.length; _l < _len4; _l++) {
        a = arguments[_l];
        _results.push((function() {
          var _results2;
          switch (typeof a) {
            case 'function':
              return app.use(a);
            case 'string':
              return use(a);
            case 'object':
              _results2 = [];
              for (k in a) {
                v = a[k];
                _results2.push(use(k, v));
              }
              return _results2;
          }
        })());
      }
      return _results;
    };
    root_locals.requiring = function() {
      var a, pairs, _l, _len4;
      pairs = {};
      for (_l = 0, _len4 = arguments.length; _l < _len4; _l++) {
        a = arguments[_l];
        pairs[a] = require(a);
      }
      return root_locals.def(pairs);
    };
    root_locals.configure = function(p) {
      var k, v, _results;
      if (typeof p === 'function') {
        return app.configure(p);
      } else {
        _results = [];
        for (k in p) {
          v = p[k];
          _results.push(app.configure(k, v));
        }
        return _results;
      }
    };
    root_locals.settings = app.settings;
    root_locals.shared = function(obj) {
      var js, k, rewritten_shared, v, _results;
      app.enable('serve zappa');
      _results = [];
      for (k in obj) {
        v = obj[k];
        js = ";zappa.run(" + v + ");";
        routes.push({
          verb: 'get',
          path: k,
          handler: js,
          contentType: 'js'
        });
        rewritten_shared = rewrite_function(v, root_names.concat(globals_names).concat(externals_names));
        _results.push(rewritten_shared(root_context, root_locals));
      }
      return _results;
    };
    root_locals.include = function(name) {
      var include_locals, include_module, k, rewritten_sub, sub, v;
      sub = root_locals.require(name);
      rewritten_sub = rewrite_function(sub.include, root_names.concat(globals_names).concat(externals_names));
      include_locals = {};
      for (k in root_locals) {
        v = root_locals[k];
        include_locals[k] = v;
      }
      include_module = require.cache[require.resolve(name)];
      include_locals.module = include_module;
      include_locals.__filename = include_module.filename;
      include_locals.__dirname = path.dirname(include_module.filename);
      return rewritten_sub(root_context, include_locals);
    };
    rewritten_root = rewrite_function(root_function, root_names.concat(globals_names).concat(externals_names));
    rewritten_root(root_context, root_locals);
    for (k in helpers) {
      v = helpers[k];
      helpers[k] = rewrite_function(v, http_names.concat(helpers_names).concat(defs_names).concat(globals_names));
    }
    for (k in ws_handlers) {
      v = ws_handlers[k];
      ws_handlers[k] = rewrite_function(v, ws_names.concat(helpers_names).concat(defs_names).concat(globals_names));
    }
    for (k in postrenders) {
      v = postrenders[k];
      postrenders[k] = rewrite_function(v, postrender_names.concat(helpers_names).concat(defs_names).concat(globals_names));
    }
    if (app.settings['serve zappa']) {
      app.get('/zappa/zappa.js', function(req, res) {
        res.contentType('js');
        return res.send(";" + coffeescript_helpers + "(" + client + ")();");
      });
    }
    if (app.settings['serve jquery']) {
      app.get('/zappa/jquery.js', function(req, res) {
        res.contentType('js');
        return res.send(jquery);
      });
    }
    if (app.settings['serve sammy']) {
      app.get('/zappa/sammy.js', function(req, res) {
        res.contentType('js');
        return ren.send(sammy);
      });
    }
    if (app.settings['default layout']) {
      views.layout = function() {
        doctype(5);
        return html(function() {
          head(function() {
            var s, _l, _len4, _len5, _m, _ref2, _ref3;
            if (this.title) {
              title(this.title);
            }
            if (this.scripts) {
              _ref2 = this.scripts;
              for (_l = 0, _len4 = _ref2.length; _l < _len4; _l++) {
                s = _ref2[_l];
                script({
                  src: s + '.js'
                });
              }
            }
            if (this.script) {
              script({
                src: this.script + '.js'
              });
            }
            if (this.stylesheets) {
              _ref3 = this.stylesheets;
              for (_m = 0, _len5 = _ref3.length; _m < _len5; _m++) {
                s = _ref3[_m];
                link({
                  rel: 'stylesheet',
                  href: s + '.css'
                });
              }
            }
            if (this.stylesheet) {
              link({
                rel: 'stylesheet',
                href: this.stylesheet + '.css'
              });
            }
            if (this.style) {
              return style(this.style);
            }
          });
          return body(this.body);
        });
      };
    }
    _fn2 = function(r) {
      var context, def, g, helper, locals, name, rewritten_handler, _len5, _m;
      if (typeof r.handler === 'string') {
        return app[r.verb](r.path, function(req, res) {
          if (r.contentType != null) {
            res.contentType(r.contentType);
          }
          return res.send(r.handler);
        });
      } else {
        rewritten_handler = rewrite_function(r.handler, http_names.concat(helpers_names).concat(defs_names).concat(globals_names));
        context = null;
        locals = {
          app: app,
          settings: app.settings
        };
        for (_m = 0, _len5 = globals_names.length; _m < _len5; _m++) {
          g = globals_names[_m];
          locals[g] = eval(g);
        }
        for (name in defs) {
          def = defs[name];
          locals[name] = def;
        }
        for (name in helpers) {
          helper = helpers[name];
          locals[name] = function() {
            return helper(context, locals, arguments);
          };
        }
        return app[r.verb](r.path, function(req, res, next) {
          var k, result, v, _ref2, _ref3, _ref4;
          context = {};
          _ref2 = req.query;
          for (k in _ref2) {
            v = _ref2[k];
            context[k] = v;
          }
          _ref3 = req.params;
          for (k in _ref3) {
            v = _ref3[k];
            context[k] = v;
          }
          _ref4 = req.body;
          for (k in _ref4) {
            v = _ref4[k];
            context[k] = v;
          }
          locals.params = context;
          locals.request = req;
          locals.response = res;
          locals.next = next;
          locals.send = function() {
            return res.send.apply(res, arguments);
          };
          locals.redirect = function() {
            return res.redirect.apply(res, arguments);
          };
          locals.render = function() {
            var args, _base, _ref5, _ref6;
            args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
                        if ((_ref5 = args[1]) != null) {
              _ref5;
            } else {
              args[1] = {};
            };
            if (typeof args[1] === 'function') {
              args.splice(1, 0, {});
            }
                        if ((_ref6 = (_base = args[1]).params) != null) {
              _ref6;
            } else {
              _base.params = locals.params;
            };
            if (args[1].postrender != null) {
              return res.render(args[0], args[1], function(err, str) {
                return jsdom.env({
                  html: str,
                  src: [jquery],
                  done: function(err, window) {
                    var doctype, rendered;
                    locals.window = window;
                    locals.$ = window.$;
                    rendered = postrenders[args[1].postrender](context, locals);
                    doctype = (window.document.doctype || '') + "\n";
                    return res.send(doctype + window.document.documentElement.outerHTML);
                  }
                });
              });
            } else {
              return res.render.apply(res, args);
            }
          };
          result = rewritten_handler(context, locals);
          if (r.contentType != null) {
            res.contentType(r.contentType);
          }
          if (typeof result === 'string') {
            return res.send(result);
          } else {
            return result;
          }
        });
      }
    };
    for (_l = 0, _len4 = routes.length; _l < _len4; _l++) {
      r = routes[_l];
      _fn2(r);
    }
    io.sockets.on('connection', function(socket) {
      var context, def, g, h, helper, locals, name, _len5, _m, _results;
      context = {};
      locals = {
        app: app,
        io: io,
        settings: app.settings,
        socket: socket,
        id: socket.id,
        client: {},
        emit: function() {
          return socket.emit.apply(socket, arguments);
        },
        broadcast: function() {
          return socket.broadcast.emit.apply(socket.broadcast, arguments);
        }
      };
      for (_m = 0, _len5 = globals_names.length; _m < _len5; _m++) {
        g = globals_names[_m];
        locals[g] = eval(g);
      }
      for (name in defs) {
        def = defs[name];
        locals[name] = def;
      }
      for (name in helpers) {
        helper = helpers[name];
        locals[name] = function() {
          return helper(context, locals, arguments);
        };
      }
      if (ws_handlers.connection != null) {
        ws_handlers.connection(context, locals);
      }
      socket.on('disconnect', function() {
        context = {};
        if (ws_handlers.disconnect != null) {
          return ws_handlers.disconnect(context, locals);
        }
      });
      _results = [];
      for (name in ws_handlers) {
        h = ws_handlers[name];
        _results.push((function(name, h) {
          if (name !== 'connection' && name !== 'disconnect') {
            return socket.on(name, function(data) {
              var k, v;
              context = {};
              for (k in data) {
                v = data[k];
                context[k] = v;
              }
              locals.params = context;
              return h(context, locals);
            });
          }
        })(name, h));
      }
      return _results;
    });
    return {
      app: app,
      io: io
    };
  };
  zappa.run = function() {
    var a, app, data, host, port, root_function, zapp, _i, _len;
    host = null;
    port = 3000;
    root_function = null;
    data = null;
    for (_i = 0, _len = arguments.length; _i < _len; _i++) {
      a = arguments[_i];
      switch (typeof a) {
        case 'string':
          host = a;
          break;
        case 'number':
          port = a;
          break;
        case 'function':
          root_function = a;
          break;
        case 'object':
          data = a;
      }
    }
    zapp = zappa.app(data, root_function);
    app = zapp.app;
    if (host) {
      app.listen(port, host);
    } else {
      app.listen(port);
    }
    log('Express server listening on port %d in %s mode', app.address().port, app.settings.env);
    log("Zappa " + zappa.version + " orchestrating the show");
    return zapp;
  };
  zappa.adapter = function(engine, options) {
    var _ref;
    if (options == null) {
      options = {};
    }
        if ((_ref = options.blacklist) != null) {
      _ref;
    } else {
      options.blacklist = [];
    };
    if (typeof engine === 'string') {
      engine = require(engine);
    }
    return {
      compile: function(template, data) {
        template = engine.compile(template, data);
        return function(data) {
          var k, v, _ref2;
          _ref2 = data.params;
          for (k in _ref2) {
            v = _ref2[k];
            if (typeof data[k] === 'undefined' && __indexOf.call(options.blacklist, k) < 0) {
              data[k] = v;
            }
          }
          return template(data);
        };
      }
    };
  };
  module.exports = zappa.run;
  module.exports.run = zappa.run;
  module.exports.app = zappa.app;
  module.exports.adapter = zappa.adapter;
  module.exports.version = zappa.version;
}).call(this);
